----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:21:38 02/11/2010 
-- Design Name: 
-- Module Name:    display - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity display is
	Port(
		display1 : in STD_LOGIC_VECTOR (15 downto 0);
		display2 : in STD_LOGIC_VECTOR (15 downto 0);
		segment0 : out STD_LOGIC_VECTOR (6 downto 0);
		segment1 : out STD_LOGIC_VECTOR (6 downto 0);
		segment2 : out STD_LOGIC_VECTOR (6 downto 0);
		segment3 : out STD_LOGIC_VECTOR (6 downto 0)
	);
end display;

architecture Behavioral of display is
component sevsegment is
	Port(
		bcd : in STD_LOGIC_VECTOR (3 downto 0);
		segment : out STD_LOGIC_VECTOR ( 6 downto 0 )
	);
end component;

component unpack is
	Port(
		input : in STD_LOGIC_VECTOR (15 downto 0);
		output : out STD_LOGIC_VECTOR (7 downto 0)
		);
end component;

signal bcd0 : STD_LOGIC_VECTOR (3 downto 0);
signal bcd1 : STD_LOGIC_VECTOR (3 downto 0);
signal bcd2 : STD_LOGIC_VECTOR (3 downto 0);
signal bcd3 : STD_LOGIC_VECTOR (3 downto 0);
signal rdisplay1 : STD_LOGIC_VECTOR (7 downto 0);
signal rdisplay2 : STD_LOGIC_VECTOR (7 downto 0);
begin

	unpack1_component: unpack
		port map (display1, rdisplay1);
	unpack2_component: unpack
		port map (display2, rdisplay2);
	

	bcd0(0) <= rdisplay1(0);
	bcd0(1) <= rdisplay1(1);
	bcd0(2) <= rdisplay1(2);
	bcd0(3) <= rdisplay1(3);
	
	bcd1(0) <= rdisplay1(4);
	bcd1(1) <= rdisplay1(5);
	bcd1(2) <= rdisplay1(6);
	bcd1(3) <= rdisplay1(7);

	bcd2(0) <= rdisplay2(0);
	bcd2(1) <= rdisplay2(1);
	bcd2(2) <= rdisplay2(2);
	bcd2(3) <= rdisplay2(3);

	bcd3(0) <= rdisplay2(4);
	bcd3(1) <= rdisplay2(5);
	bcd3(2) <= rdisplay2(6);
	bcd3(3) <= rdisplay2(7);
	
	seg0_component: sevsegment
		port map (bcd0, segment0);
	seg1_component: sevsegment
		port map (bcd1, segment1);
	seg2_component: sevsegment
		port map (bcd2, segment2);
	seg3_component: sevsegment
		port map (bcd3, segment3);


end Behavioral;

